function love.load()

  --Setup for Screen Resolution
  push = require "push"

  local gameWidth, gameHeight = 1024, 576 --fixed game resolution
  windowWidth, windowHeight = love.window.getDesktopDimensions()

  windowWidth, windowHeight = windowWidth*.7, windowHeight*.7 --make the window a bit smaller than the screen itself

  push:setupScreen(gameWidth, gameHeight, windowWidth, windowHeight, {fullscreen = false})

  --Load Needed Assets
  require "player"
  require "wall"
  require "level1"
  require "level2"
  require "Bad"
  require "win"
  require "superbad"
  require "bomb"
  require "mine"
  bump = require "bump"
  
  isDead = false
  newLevel = false
  currentLevel = 1
  curtainX = -1*windowWidth
  
  --Load in Levels
  generateLevel1()

end

function love.update(dt)

--moves each item if game isn't over or changing
if isDead == false and newLevel == false then player.update(dt) end
if isDead == false and newLevel == false then listofbad.update(dt) end
if isDead == false and newLevel == false then listofsuperbad.update(dt) end
if isDead == false and newLevel == false then listofbomb.update(dt) end
  
  if isDead then
    --clears out gamne and resets after death
    wipeScreen(dt)
        
  end
  
  if newLevel then
    --Clears screen then moves to the next level
    wipeScreen(dt)
    
  end
  
end

function love.draw()
  push:start()
  
  local items, len = world:getItems()
for i = 1, len do
  local x, y, w, h = world:getRect(items[i])
  love.graphics.rectangle("line", x, y, w, h)
end

  win.draw()
  listofwalls.draw()
  player.draw()
  listofsuperbad.draw()
  listofbomb.draw()
  listofbad.draw()
  listofmine.draw()
  
  --draws the rectangle used for level change and reset animation
  if isDead then
    love.graphics.setColor(255,255,255)
    love.graphics.rectangle("fill", curtainX-50,0, windowWidth,windowHeight)
  end
  
  if newLevel then
    love.graphics.setColor(255,255,255)
    love.graphics.rectangle("fill", curtainX-50,0, windowWidth,windowHeight)
  end
  
  push:finish()
end
function respawn()
  if currentLevel == 1 then generateLevel1()
  elseif currentLevel == 2 then generateLevel2() 
  end
end

function wipeScreen(dt)
  --runs the animation of the switch between levels and resetting the level
  if os.time()-start < 1 then trigger = 0 end
  
  if curtainX < 0 and trigger == 0 then
    curtainX = curtainX + (555*dt)
    
  elseif curtainX >= 0 and trigger == 0 then
      player.reset()
      listofbad.reset()
      listofwalls.reset()
      listofbomb.reset()
      listofsuperbad.reset()
      listofmine.reset()
      win.reset()
      respawn()
      trigger = 1
    
  elseif trigger == 1 and curtainX > -1*windowWidth then
    curtainX = curtainX - (555*dt)
    
  elseif curtainX <= -1*windowWidth  then
    newLevel = false
    isDead = false
    trigger = 0

  end
end

function nextLevel(dt)
  --freezes all sprites and moves to next level.
  start = os.time()
  currentLevel = currentLevel+1
  for i,v in ipairs(listofbad) do v.speed = 0 end
  for i,v in ipairs(listofsuperbad) do v.speed = 0 end
  for i,v in ipairs(listofbomb) do v.speed = 0 end
  player.speed = 0
  newLevel = true
  
end
function table.removekey(table, key)
  --removes a specific object from being drawn or recorded
   local element = table[key]
   table[key] = nil
   return element
end
