player = {}
require "main"

function createPlayer(x, y)
  
  player.x = x
	player.y = y
	player.width = 17
	player.height = 32
	player.xdir = 0
	player.ydir = 0
	player.friction = 0
	player.speed = 150
  player.isPlayer = true
  player.img = love.graphics.newImage("Graphics/player.png")
  
end
function player.update(dt)
  
  player.move(dt)
  
end

function player.move(dt)
  
  local playerFilter = function(player, other)
    if other.isBad then return 'cross'
    elseif other.isWall then return 'touch'
    elseif other.isWin then return 'cross'
    elseif other.isSuperBad then return 'cross'
    elseif other.isBomb then return 'cross'
    elseif other.isMine then return 'cross'
    end
  end
  
  local goalX = player.x + (player.speed*player.xdir*dt)
  local goalY = player.y + (player.speed*player.ydir*dt)
  
  local actualX, actualY, cols, len = world:move(player, goalX, goalY, playerFilter)
  
  player.x, player.y = actualX, actualY
  
  
  for i = 1, len do
    local col = cols[i]
    local other = col.other
    
      if other.isBad or other.isSuperBad or other.isBomb or other.isMine then
        --Kills player if they hit these
        playerKill()
      
      elseif other.isWin then
      --Begins process for going to next level
        world:remove(other)
        table.removekey(win,other)
        nextLevel(dt)
      end
    
  end
  
end

function player.draw()
  
  love.graphics.draw(player.img,player.x,player.y)
  
end
function love.keypressed(key, scancode, isrepeat)
  --Exits game on pressing excape
   if key == "escape" then
      love.event.quit()
   end
   
   if key == "0" then nextLevel(dt) end
   if key == "1" then
     currentLevel = currentLevel -2
     nextLevel(dt) 
     end
   
   if isDead == false then
     
    if key == "left" or key == "a"  then
      player.ydir = 0
      player.xdir = -1
    end
   
    if key == "right" or key == "d"  then
      player.ydir = 0
      player.xdir = 1
    end
   
    if key == "up" or key == "w"  then
      player.xdir = 0
      player.ydir = -1
    end
   
    if key == "down" or key == "s"  then
      player.xdir = 0
      player.ydir = 1
    end
    
  end
   
end
function playerKill()
  world:remove(player)
  start = os.time()
  player.img = love.graphics.newImage("Graphics/splode.png")
  isDead = true
  player.speed = 0
end

function player.reset()
    for i=0, 10 do rawset(player, i, nil) end
end